#include <iostream>
#include <ArgsParser.hpp>

int main(int argc, char* argv[]) {

    std::vector<std::string> arguments (argv, argv+argc);


    for (auto& entry : arguments) {
        std::cout << entry << " ";
    }
    std::cout << std::endl;

    std::vector<std::string> fakeArgs {"--output", "console", "hello!!", "--color", "#FFFFFF", "what's up?", "--color", "#420690", "Damn jit", "--color", "#FFFFFF"}; //{"--verbose", "--file", "thf", "bruhbruh"};


    ArgsParser args(fakeArgs);

    auto output = args.consume_flag_arg("--output");


    if (args.has_flag("--help")) {

        std::cout << "Help information displayed here!" << std::endl;
        return 0;
    }

    //for (auto args.)

    for (auto& arg : args.get_remaining_args()) {
        if (arg == "--color") {

        }
    }


    std::vector<std::string> color_codes = args.consume_flag_arg_multiple("--color");


    if (args.has_flag("--file")) {
        if (args.has_flag_arg("--file")) {
            auto filename = args.consume_flag_arg("--file");

            if (filename.has_value()) {
                std::cout << "Filename: " << filename.value() << std::endl;

            }
        }
    }

    for (auto& entry : args.get_remaining_args()) {
        std::cout << entry << " ";
    }
    std::cout << std::endl;

    while (args.has_next()) {
        std::string token = args.consume_next();

        std::cout << token << " ";
    }

    std::cout << std::endl;


    return 0;
}